import {jsx as $cY8Sl$jsx} from "preact/jsx-runtime";
import "preact";
import {useRef as $cY8Sl$useRef, useEffect as $cY8Sl$useEffect, useState as $cY8Sl$useState, useCallback as $cY8Sl$useCallback} from "preact/hooks";
import {memo as $cY8Sl$memo} from "preact/compat";
import {EditorView as $cY8Sl$EditorView} from "@codemirror/view";
import {Compartment as $cY8Sl$Compartment, EditorState as $cY8Sl$EditorState} from "@codemirror/state";
import {setDiagnostics as $cY8Sl$setDiagnostics} from "@codemirror/lint";








let $766cd1af48d58c41$var$readOnlyCompartment = new (0, $cY8Sl$Compartment)();
function $766cd1af48d58c41$export$e6a0daad8304de(value, extensions) {
    return (0, $cY8Sl$EditorState).create({
        doc: value,
        extensions: [
            ...extensions,
            $766cd1af48d58c41$var$readOnlyCompartment.of((0, $cY8Sl$EditorView).editable.of(false))
        ]
    });
}
const $766cd1af48d58c41$var$emittedStates = new WeakSet();
const $766cd1af48d58c41$export$ada5f069beef6fb2 = (0, $cY8Sl$memo)(function({ state: state , onChange: onChange = null , readOnly: readOnly = false , diagnostics: diagnostics = null , ...rest }) {
    if (!state) throw new Error("Missing state!");
    const container = (0, $cY8Sl$useRef)(null);
    const view = (0, $cY8Sl$useRef)(null);
    const dispatchRefs = (0, $cY8Sl$useRef)({});
    (0, $cY8Sl$useEffect)(()=>{
        dispatchRefs.current.onChange = onChange;
    }, [
        onChange
    ]);
    // --- State ---
    (0, $cY8Sl$useEffect)(()=>{
        // (subsequent render)
        if (!view.current) return;
        if ($766cd1af48d58c41$var$emittedStates.has(state)) return;
        view.current.setState(state);
    }, [
        state
    ]);
    (0, $cY8Sl$useEffect)(()=>{
        // (first render)
        let v = view.current = new (0, $cY8Sl$EditorView)({
            state: state,
            dispatch: (t)=>{
                const { onChange: onChange  } = dispatchRefs.current;
                v.update([
                    t
                ]);
                if (onChange) {
                    $766cd1af48d58c41$var$emittedStates.add(v.state);
                    onChange(v.state, t);
                }
            }
        });
        container.current.appendChild(v.dom);
        return ()=>v.destroy();
    }, []);
    // --- readOnly ---
    (0, $cY8Sl$useEffect)(()=>{
        // if readOnly changes (first and subsequent render)
        view.current.dispatch({
            effects: $766cd1af48d58c41$var$readOnlyCompartment.reconfigure((0, $cY8Sl$EditorState).readOnly.of(readOnly))
        });
    }, [
        readOnly
    ]);
    (0, $cY8Sl$useEffect)(()=>{
        // reapply readOnly if the state was changed externally
        if ($766cd1af48d58c41$var$emittedStates.has(state)) return;
        view.current.dispatch({
            effects: $766cd1af48d58c41$var$readOnlyCompartment.reconfigure((0, $cY8Sl$EditorState).readOnly.of(readOnly))
        });
    }, [
        readOnly,
        state
    ]);
    // --- Diagnostics ---
    (0, $cY8Sl$useEffect)(()=>{
        // if diagnostics changes (first and subsequent render)
        view.current.dispatch((0, $cY8Sl$setDiagnostics)(view.current.state, diagnostics && diagnostics.length > 0 ? diagnostics : []));
    }, [
        diagnostics
    ]);
    (0, $cY8Sl$useEffect)(()=>{
        // reapply diagnostics if the state was changed externally
        if ($766cd1af48d58c41$var$emittedStates.has(state)) return;
        view.current.dispatch((0, $cY8Sl$setDiagnostics)(view.current.state, diagnostics && diagnostics.length > 0 ? diagnostics : []));
    }, [
        diagnostics,
        state
    ]);
    return /*#__PURE__*/ (0, $cY8Sl$jsx)("div", {
        ref: container,
        ...rest
    });
});
function $766cd1af48d58c41$export$a70089b54cfe6d6a({ value: value , onChange: _onChange , readOnly: readOnly , diagnostics: diagnostics , extensions: extensions , ...rest }) {
    const [state, setState] = (0, $cY8Sl$useState)($766cd1af48d58c41$export$e6a0daad8304de(value, extensions));
    (0, $cY8Sl$useEffect)(()=>{
        if (value !== state.doc.toString()) setState($766cd1af48d58c41$export$e6a0daad8304de(value, extensions));
    }, [
        value
    ]);
    (0, $cY8Sl$useEffect)(()=>{
        setState($766cd1af48d58c41$export$e6a0daad8304de(value, extensions));
    }, [
        extensions
    ]);
    const onChange = (0, $cY8Sl$useCallback)((newState, transaction)=>{
        setState(newState);
        if (!transaction.changes.empty) _onChange(newState.doc.toString());
    }, []);
    return /*#__PURE__*/ (0, $cY8Sl$jsx)($766cd1af48d58c41$export$ada5f069beef6fb2, {
        state: state,
        onChange: onChange,
        readOnly: readOnly,
        diagnostics: diagnostics,
        ...rest
    });
}


export {$766cd1af48d58c41$export$e6a0daad8304de as createState, $766cd1af48d58c41$export$ada5f069beef6fb2 as Codemirror, $766cd1af48d58c41$export$a70089b54cfe6d6a as CodemirrorEditor};
//# sourceMappingURL=index.es.js.map
